#![cfg_attr(not(feature = "std"), no_std)]

#[cfg(not(feature = "std"))]
pub mod api;
pub mod board;
pub mod entities;
pub mod sim;

#[cfg(not(feature = "std"))]
extern crate alloc;

use std_bis::*;

pub mod std_bis {
	#[cfg(not(feature = "std"))]
	pub use alloc::{boxed::Box, format, vec, vec::Vec};
}

#[cfg(feature = "std")]
pub mod prelude {
	pub use crate::{
		board::{Board, Direction, Position},
		entities::{ferris::Ferris, traits::Walker, Entity, WalkError},
		sim::{EntityId, Sim, SimError, SimId},
	};
}

#[cfg(not(feature = "std"))]
pub mod prelude {
	pub use crate::{
		api::api::*,
		board::{Board, Direction, Position},
		entities::WalkError,
		sim::{EntityId, SimError, SimId},
	};
}
